<template>
    <main>
        <div class="h1-container">
            <h1 class="h1-with-line text-shadow"> Настройки</h1>
            <div class="h1-line"></div>
            <div class="clear"></div>
        </div>
        <div class="settings flex-parent flex-justify-center">
            <div class="profile">
                <div class="photo-profile">Фото профиля</div>
                <div v-show="!user.image && !showPreview">
                    <input type="file" id="file" ref="file" v-on:change="onChangeFileUpload()" class="inputfile">
                    <label for="file" class="place-photo flex-parent flex-justify-center flex-align-center" >
                        <a>+</a>
                    </label>
                </div>
                    <img v-bind:src="imagePreview || userInfo.image" class="place-photo" v-show="showPreview || userInfo.image"/>
                    <input v-if="showPreview || userInfo.image" type="file"  ref="file" v-on:change="onChangeFileUpload()"/>
                    <input type="text" class="text-input" placeholder="Имя"
                           v-model="userInfo.first_name" title="имя" maxlength="20" id="name">
                    <input type="text" class="text-input" placeholder="Фамилия"
                           v-model="userInfo.last_name" title="имя" maxlength="20"
                           id="last-name">
                    <div class="flex-parent">
                        <div class="for-radio flex-parent">
                            <label for="gender-man" class="radio-label">M</label>
                            <input id="gender-man" v-model="userInfo.gender" value="m" class="radio" type="radio" name="gender">
                        </div>
                        <div class="for-radio flex-parent">
                            <label class="radio-label" for="group-student">Ученик</label>
                            <input id="group-student"  v-model="userInfo.usertype" class="radio"  value="s" type="radio" name="group">
                        </div>
                        <div class="for-radio flex-parent">
                            <label for="gender-woman" class="radio-label">Ж</label>
                            <input id="gender-woman" v-model="userInfo.gender" value="f" class="radio" type="radio" name="gender">
                        </div>
                        <div class="for-radio flex-parent">
                            <label for="group-parent" class="radio-label">Родитель</label>
                            <input id="group-parent" v-model="userInfo.usertype"  value="p" class="radio" type="radio" name="group">
                        </div>
                    </div>
                <select class="select" v-model="userInfo.region" required>
                    <option :value="null" disabled selected>Область</option>
                    <option disabled selected v-if="!regions">Загрузка</option>
                    <option v-for="region in regions" v-bind:value="region.id" v-bind:key="region.id">{{region.name}}</option>
                </select>
                <select class="select" v-model="userInfo.city" required>
                    <option :value="null" disabled selected>Город</option>
                    <option disabled selected v-if="!cities">Загрузка</option>
                    <option v-for="city in cities" v-bind:value="city.id" v-bind:key="city.id">{{city.name}}</option>
                </select>
                <select class="select" v-model="userInfo.school" required>
                    <option :value="null" disabled selected>Школа</option>
                    <option disabled selected v-if="!schools">Загрузка</option>
                    <option v-for="school in schools" v-bind:value="school.id" v-bind:key="school.id">{{school.name}}</option>
                </select>
                <select class="select" v-model="userInfo.level" required>
                    <option :value="null" disabled selected>Класс</option>
                    <option :value="i" v-for="i in 12">{{i}} класс</option>
                    <option value="13">Другое</option>
                </select>
                <select class="select" v-model="userInfo.language" required>
                    <option value="" disabled selected>Язык обучение</option>
                    <option value="eng">English</option>
                    <option value="rus">Русский</option>
                    <option value="kaz">Қазақша</option>
                </select>
                <button class="a-btn" @click="sendData" :disabled="sentUserData">Сохранить</button>
                <div class="change_password">
                    <div class="change_word">Изменить пароль</div>
                    <input type="text" class="change" placeholder="Новый пароль" >
                    <input type="text" class="change" placeholder="Повторить пароль" >
                    <button class="a-btn" :disabled="sentPassword">Сохранить</button>
                </div>


            </div>
            <div class="shopping-list">
                <div class="shopping-list-title"> Список покупок</div>
                <div class="period">
                    <div class="word-period"><a href="">Алгебра 9 класс: период</a> </div>
                    <div class="word-period"><a href="">Алгебра 9 класс: период</a> </div>
                    <div class="word-period"><a href="">Алгебра 9 класс: период</a> </div>
                    <div class="word-period"><a href="">Алгебра 9 класс: период</a> </div>
                    <div class="word-period"><a href="">Алгебра 9 класс: период</a> </div>
                    <div class="word-period"><a href="">Алгебра 9 класс: период</a> </div>
                </div>
            </div>

        </div>
    </main>
</template>
<style>
    .inputfile {
        width: 0.1px;
        height: 0.1px;
        opacity: 0;
        overflow: hidden;
        position: absolute;
        z-index: -1;
    }

    .inputfile + label {
        cursor: pointer; /* "hand" cursor */
    }
</style>
<script>
    export default {
        name: 'Settings',
        data(){
          return{
              file: '',
              showPreview: false,
              imagePreview: '',
              userInfo: {
                  first_name: '',
                  city: '',
                  gender: '',
                  image: '',
                  language:'',
                  last_name: '',
                  level: '',
                  region: '',
                  school: '',
                  usertype: '',
              },
              sentUserData: false,
              sentPassword: false,
          }
        },
        computed:{
            user(){
                let userInfo = this.$store.getters.user;
                let userInfoArr = Object.entries(userInfo);
                let that = this;
                userInfoArr.forEach((data)=>{
                    that.userInfo[data[0]] = data[1]
                })
                console.log(this)
                return userInfo;
            },
            regions(){
                return this.$store.getters.regions;
            },
            cities(){
                return this.$store.getters.cities;
            },
            schools(){
                return this.$store.getters.schools;
            }
        },
        methods: {
            onChangeFileUpload(){
                this.file = this.$refs.file.files[0];
                console.log(this.file)
                let reader  = new FileReader();


                reader.addEventListener("load", function () {
                    this.showPreview = true;
                    this.imagePreview = reader.result;
                }.bind(this), false);


                if( this.file ){

                    if ( /\.(jpe?g|png|gif)$/i.test( this.file.name ) ) {

                        reader.readAsDataURL( this.file );
                    }
                }
            },
            sendData(){
                let data = new FormData();
                if(this.file){
                    data.append('image', this.file);
                }
                let userInfoArr = Object.entries(this.userInfo);
                let that = this;
                userInfoArr.forEach((info)=>{
                    if(info[1]!=='' && info[1]!==null){
                        data.append(info[0],info[1]);
                    }

                })
                for(var pair of data.entries()) {
                    console.log(pair[0]+ ', '+ pair[1]);
                }
                this.sentUserData = true
                this.$store.dispatch('updateProfile', data).then(()=>{
                    this.$modal.show('successOrError-modal', {error: false})
                    this.sentUserData = false;
                }).catch(()=>{
                    this.$modal.show('successOrError-modal', {error: true})
                    this.sentUserData = false;
                })
            }
        },
        watch: {
            'userInfo.region': function (val, oldVal){
                if(val!==oldVal){
                    this.city = '';
                    this.schools = '';
                    this.$store.dispatch('loadCities', this.userInfo.region)
                }
            },
            'userInfo.city': function (val, oldVal){
                if(val!==oldVal){
                    this.schools = '';
                    this.$store.dispatch('loadSchools', this.userInfo.city)
                }
            }
        },
    }
</script>
